#version 420

uniform sampler2D scatter;
uniform float time;
in vec2 out_TexCoord;

const int NUM_SAMPLES = 100;

layout(location = 0) out vec4 fragColor;
void main()
{

	float exposure = 0.1f;
	float decay = 0.2f;
	float density = 0.3f;
	float weight = 0.2f;
	vec2 lightPositionOnScreen = vec2(0.5f, 0.5f);
	vec2 deltaTextCoord = vec2( out_TexCoord.st - lightPositionOnScreen.xy );
 	vec2 textCoo = vec2(out_TexCoord.st);
 	deltaTextCoord *= 0.2 /  NUM_SAMPLES * density;
 	float illuminationDecay = 1.0;
 	for(int i=0; i < NUM_SAMPLES ; i++)
  	{
    			textCoo -= deltaTextCoord;
    			vec4 texel = texture2D(scatter, textCoo );
    			texel *= illuminationDecay * weight;
    			fragColor += texel;
    			illuminationDecay *= decay;
 	}
 	fragColor *= exposure;
 // 	vec2 texcoord = out_TexCoord;
	// texcoord.x += (sin(time*5+out_TexCoord.y) + cos(time*2+out_TexCoord.x/(out_TexCoord.x + 1)))/10;
	// texcoord.y += (sin(time*4+out_TexCoord.y) + cos(time*3 + out_TexCoord.x/(out_TexCoord.y + 1)))/10;
	// vec4 finalColor = texture2D(scatter,texcoord);

	// finalColor.r = finalColor.r + (sin(time/3 + out_TexCoord.x + out_TexCoord.y)+1)/2;
	// finalColor.g = finalColor.g + (cos(time/2 + +out_TexCoord.y + out_TexCoord.x/3)+1)/2;
	// finalColor.b = finalColor.b + (sin(time/4 + out_TexCoord.y/2)+1)/2;
	// finalColor.a;

	// //fragColor = vec4(1.0, 1.0, 1.0, 1.0);
	// fragColor = finalColor;

}

